__version__ = '$Revision: 1.17.2.5 $'[11:-2]

from Globals import package_home
from Products.Archetypes.public import process_types, listTypes
import Products.CMFCore.utils as cmfcore_utils
from Products.CMFCore.DirectoryView import registerDirectory
from Products.CMFCore.utils import getToolByName
from Products.CMFCore.CMFCorePermissions import ManagePortal

from config import SKINS_DIR, GLOBALS, PROJECTNAME
from config import ADD_CONTENT_PERMISSION

import ForumWorkflow, SizeValidator, ForumMailLoader, ForumMailSpool

registerDirectory(SKINS_DIR, GLOBALS)

import traceback

def initialize(context):
    try:
        import ForumTopic
    except:
        traceback.print_exc()
        raise
    
    import Forum, ForumFolder, ForumTopic, ForumContentTopic, ForumMessage
    import DiscussionTool, DiscussionFilter
    
    try:
        import ForumPoll
    except ImportError, e:
        pass

    content_types, constructors, ftis = process_types(
        listTypes(PROJECTNAME),
        PROJECTNAME)

    cmfcore_utils.ContentInit(
        PROJECTNAME + ' Content',
        content_types      = content_types,
        permission         = ADD_CONTENT_PERMISSION,
        extra_constructors = constructors,
        fti                = ftis,
        ).initialize(context)

    cmfcore_utils.ToolInit(
        PROJECTNAME + ' Tools'
        , tools = (DiscussionTool.ForumDiscussionTool,
                   DiscussionFilter.ForumDiscussionFilter,
                   ForumMailSpool.MailSpool,
                   ForumMailLoader.MailLoader,
                   )
        , product_name = PROJECTNAME
        , icon='tool.gif'
        ).initialize(context)


from striphtml import strip
from utils import forum_parser

methods = {'fcForum_striphtml': strip,
           'fcForum_parser': forum_parser}


try:
    import forum_export, forum_import
    from AccessControl import ModuleSecurityInfo, allow_module
                                                                                                                         
    ModuleSecurityInfo('Products.CMFBoard.forum_export').declareProtected(ManagePortal, 'forum_export')
    ModuleSecurityInfo('Products.CMFBoard.forum_import').declareProtected(ManagePortal, 'forum_import')
    allow_module('Products.CMFBoard.forum_export')
    allow_module('Products.CMFBoard.forum_import')
except:
    pass
